if (R.VTK.BASE==1){
vtkGenericDataSet <- function(.me=environment()){
  .me <- vtkDataObject(.me)
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkGenericDataSet_IsTypeOf",.me$obj, .type,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkGenericDataSet_IsA",.me$obj, .type,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkGenericDataSet_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK")
    res$ret.val <- vtkGenericDataSet(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkGenericDataSet_NewInstance",.me$obj,PACKAGE="RVTK")
    res$ret.val <- vtkGenericDataSet(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfPoints <- function(){
    res<-.Call("R_vtkGenericDataSet_GetNumberOfPoints",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfCells <- function( .dim){
    res<-.Call("R_vtkGenericDataSet_GetNumberOfCells",.me$obj, .dim,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellDimension <- function(){
    res<-.Call("R_vtkGenericDataSet_GetCellDimension",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellTypes <- function( .types=vtkCellTypes()){
    check.VTK(.types,"vtkCellTypes")
    res<-.Call("R_vtkGenericDataSet_GetCellTypes",.me$obj, .types$obj,PACKAGE="RVTK")
    res$.types <- vtkCellTypes(wrapenv(res$.types))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewCellIterator <- function( .dim){
    res<-.Call("R_vtkGenericDataSet_NewCellIterator",.me$obj, .dim,PACKAGE="RVTK")
    res$ret.val <- vtkGenericCellIterator(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewBoundaryIterator <- function( .dim, .exteriorOnly){
    res<-.Call("R_vtkGenericDataSet_NewBoundaryIterator",.me$obj, .dim, .exteriorOnly,PACKAGE="RVTK")
    res$ret.val <- vtkGenericCellIterator(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewPointIterator <- function(){
    res<-.Call("R_vtkGenericDataSet_NewPointIterator",.me$obj,PACKAGE="RVTK")
    res$ret.val <- vtkGenericPointIterator(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$FindCell <- function( .x=as.double(rep.int(1,3)), .cell=vtkGenericCellIterator(), .tol2, .subId=as.integer(rep.int(1,1)), .pcoords=as.double(rep.int(1,3))){
    check.VTK(.cell,"vtkGenericCellIterator")
    res<-.Call("R_vtkGenericDataSet_FindCell",.me$obj, .x, .cell$obj, .tol2, .subId, .pcoords,PACKAGE="RVTK")
    res$.cell <- vtkGenericCellIterator(wrapenv(res$.cell))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$FindPoint <- function( .x=as.double(rep.int(1,3)), .p=vtkGenericPointIterator()){
    check.VTK(.p,"vtkGenericPointIterator")
    res<-.Call("R_vtkGenericDataSet_FindPoint",.me$obj, .x, .p$obj,PACKAGE="RVTK")
    res$.p <- vtkGenericPointIterator(wrapenv(res$.p))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetMTime <- function(){
    res<-.Call("R_vtkGenericDataSet_GetMTime",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ComputeBounds <- function(){
    res<-.Call("R_vtkGenericDataSet_ComputeBounds",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetBounds <- function(){
    res<-.Call("R_vtkGenericDataSet_GetBounds",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetBounds_v1 <- function( .bounds=as.double(rep.int(1,6))){
    res<-.Call("R_vtkGenericDataSet_GetBounds_v1",.me$obj, .bounds,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCenter <- function(){
    res<-.Call("R_vtkGenericDataSet_GetCenter",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCenter_v1 <- function( .center=as.double(rep.int(1,3))){
    res<-.Call("R_vtkGenericDataSet_GetCenter_v1",.me$obj, .center,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetLength <- function(){
    res<-.Call("R_vtkGenericDataSet_GetLength",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetAttributes <- function(){
    res<-.Call("R_vtkGenericDataSet_GetAttributes",.me$obj,PACKAGE="RVTK")
    res$ret.val <- vtkGenericAttributeCollection(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetTessellator <- function( ._arg=vtkGenericCellTessellator()){
    check.VTK(._arg,"vtkGenericCellTessellator")
    res<-.Call("R_vtkGenericDataSet_SetTessellator",.me$obj, ._arg$obj,PACKAGE="RVTK")
    res$._arg <- vtkGenericCellTessellator(wrapenv(res$._arg))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetTessellator <- function(){
    res<-.Call("R_vtkGenericDataSet_GetTessellator",.me$obj,PACKAGE="RVTK")
    res$ret.val <- vtkGenericCellTessellator(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetActualMemorySize <- function(){
    res<-.Call("R_vtkGenericDataSet_GetActualMemorySize",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetDataObjectType <- function(){
    res<-.Call("R_vtkGenericDataSet_GetDataObjectType",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetEstimatedSize <- function(){
    res<-.Call("R_vtkGenericDataSet_GetEstimatedSize",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  class(.me) <- c("vtkGenericDataSet",class(.me))
  return(.me)
}
}
