if (R.VTK.BASE==1){
vtkVoxel <- function(.me=environment()){
  .me <- vtkCell3D(.me)
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkVoxel_IsTypeOf",.me$obj, .type,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkVoxel_IsA",.me$obj, .type,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkVoxel_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK")
    res$ret.val <- vtkVoxel(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkVoxel_NewInstance",.me$obj,PACKAGE="RVTK")
    res$ret.val <- vtkVoxel(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetEdgePoints <- function( .edgeId, .pts){
    res<-.Call("R_vtkVoxel_GetEdgePoints",.me$obj, .edgeId, .pts,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetFacePoints <- function( .faceId, .pts){
    res<-.Call("R_vtkVoxel_GetFacePoints",.me$obj, .faceId, .pts,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetParametricCoords <- function(){
    res<-.Call("R_vtkVoxel_GetParametricCoords",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellType <- function(){
    res<-.Call("R_vtkVoxel_GetCellType",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellDimension <- function(){
    res<-.Call("R_vtkVoxel_GetCellDimension",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfEdges <- function(){
    res<-.Call("R_vtkVoxel_GetNumberOfEdges",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfFaces <- function(){
    res<-.Call("R_vtkVoxel_GetNumberOfFaces",.me$obj,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetEdge <- function( .edgeId){
    res<-.Call("R_vtkVoxel_GetEdge",.me$obj, .edgeId,PACKAGE="RVTK")
    res$ret.val <- vtkCell(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetFace <- function( .faceId){
    res<-.Call("R_vtkVoxel_GetFace",.me$obj, .faceId,PACKAGE="RVTK")
    res$ret.val <- vtkCell(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Contour <- function( .value, .cellScalars=vtkDataArray(), .locator=vtkPointLocator(), .verts=vtkCellArray(), .lines=vtkCellArray(), .polys=vtkCellArray(), .inPd=vtkPointData(), .outPd=vtkPointData(), .inCd=vtkCellData(), .cellId, .outCd=vtkCellData()){
    check.VTK(.cellScalars,"vtkDataArray")
    check.VTK(.locator,"vtkPointLocator")
    check.VTK(.verts,"vtkCellArray")
    check.VTK(.lines,"vtkCellArray")
    check.VTK(.polys,"vtkCellArray")
    check.VTK(.inPd,"vtkPointData")
    check.VTK(.outPd,"vtkPointData")
    check.VTK(.inCd,"vtkCellData")
    check.VTK(.outCd,"vtkCellData")
    res<-.Call("R_vtkVoxel_Contour",.me$obj, .value, .cellScalars$obj, .locator$obj, .verts$obj, .lines$obj, .polys$obj, .inPd$obj, .outPd$obj, .inCd$obj, .cellId, .outCd$obj,PACKAGE="RVTK")
    res$.cellScalars <- vtkDataArray(wrapenv(res$.cellScalars))
    res$.locator <- vtkPointLocator(wrapenv(res$.locator))
    res$.verts <- vtkCellArray(wrapenv(res$.verts))
    res$.lines <- vtkCellArray(wrapenv(res$.lines))
    res$.polys <- vtkCellArray(wrapenv(res$.polys))
    res$.inPd <- vtkPointData(wrapenv(res$.inPd))
    res$.outPd <- vtkPointData(wrapenv(res$.outPd))
    res$.inCd <- vtkCellData(wrapenv(res$.inCd))
    res$.outCd <- vtkCellData(wrapenv(res$.outCd))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$EvaluatePosition <- function( .x=as.double(rep.int(1,3)), .closestPoint, .subId=as.integer(rep.int(1,1)), .pcoords=as.double(rep.int(1,3)), .dist2=as.double(rep.int(1,1)), .weights){
    res<-.Call("R_vtkVoxel_EvaluatePosition",.me$obj, .x, .closestPoint, .subId, .pcoords, .dist2, .weights,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Triangulate <- function( .index, .ptIds=vtkIdList(), .pts=vtkPoints()){
    check.VTK(.ptIds,"vtkIdList")
    check.VTK(.pts,"vtkPoints")
    res<-.Call("R_vtkVoxel_Triangulate",.me$obj, .index, .ptIds$obj, .pts$obj,PACKAGE="RVTK")
    res$.ptIds <- vtkIdList(wrapenv(res$.ptIds))
    res$.pts <- vtkPoints(wrapenv(res$.pts))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InterpolationFunctions <- function( .pcoords=as.double(rep.int(1,3)), .sf=as.double(rep.int(1,8))){
    res<-.Call("R_vtkVoxel_InterpolationFunctions",.me$obj, .pcoords, .sf,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InterpolationDerivs <- function( .pcoords=as.double(rep.int(1,3)), .derivs=as.double(rep.int(1,24))){
    res<-.Call("R_vtkVoxel_InterpolationDerivs",.me$obj, .pcoords, .derivs,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetEdgeArray <- function( .edgeId){
    res<-.Call("R_vtkVoxel_GetEdgeArray",.me$obj, .edgeId,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetFaceArray <- function( .faceId){
    res<-.Call("R_vtkVoxel_GetFaceArray",.me$obj, .faceId,PACKAGE="RVTK")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  if (identical(.me,environment())){
   .me$obj <- .Call("R_vtkVoxel_New")
    reg.finalizer(.me, .me$Delete)
  }
  class(.me) <- c("vtkVoxel",class(.me))
  return(.me)
}
}
