vtkCubeSource()-> CubeModel
	CubeModel$SetCenter(.5,.5,.5)
vtkExtractEdges()-> Edges
	Edges$SetInput(CubeModel$GetOutput())
vtkTubeFilter()-> Tubes
	Tubes$SetInput(Edges$GetOutput())
	Tubes$SetRadius(.01)
	Tubes$SetNumberOfSides(6)
	Tubes$UseDefaultNormalOn()
	Tubes$SetDefaultNormal(.577,.577,.577)
# Create the mapper and actor to display the cube edges.
vtkPolyDataMapper()-> TubeMapper
	TubeMapper$SetInput(Tubes$GetOutput())
vtkActor()->CubeEdges
	CubeEdges$SetMapper(TubeMapper)
	CubeEdges$GetProperty()$SetDiffuseColor(0.1,0.2,0.3)
	CubeEdges$GetProperty()$SetSpecular(.4)
	CubeEdges$GetProperty()$SetSpecularPower(10)

# Create a sphere to use as a glyph source for vtkGlyph3D.
vtkSphereSource()->Sphere
  Sphere$SetRadius( 0.04)
  Sphere$SetPhiResolution(20)
  Sphere$SetThetaResolution(20)

vtkGlyph3D() ->Vertices
  Vertices$SetInput(CubeModel$GetOutput())
  Vertices$SetSource(Sphere$GetOutput())
# Create a mapper and actor to display the glyphs.
vtkPolyDataMapper()-> SphereMapper
  SphereMapper$SetInput(Vertices$GetOutput())
  SphereMapper$ScalarVisibilityOff()
vtkActor()->CubeVertices
  CubeVertices$SetMapper(SphereMapper)
  CubeVertices$GetProperty()$SetDiffuseColor(0.5,0.6,0.7)

vtkRenderer()->ren1

ren1$AddActor(CubeEdges)
ren1$AddActor(CubeVertices)
.vtk$AddRenderer(ren1)
