vtkPoints()->points
    points$SetData(DoubleArray(Theoph[3:5]))

vtkPolyData()->profile
    profile$SetPoints(points)

vtkDelaunay2D()->del
    del$SetInput(profile)
    del$SetTolerance(0.001)

vtkPolyDataMapper()->mapMesh
    mapMesh$SetInput(del$GetOutput())

vtkSphereSource()->Sphere
  Sphere$SetRadius( 0.4)
  Sphere$SetPhiResolution(12)
  Sphere$SetThetaResolution(12)

vtkGlyph3D() ->Vertices
  Vertices$SetInput(del$GetOutput())
  Vertices$SetSource(Sphere$GetOutput())

vtkPolyDataMapper()->mapPoints
    mapPoints$SetInput(Vertices$GetOutput())

vtkActor()->meshVertices
   meshVertices$SetMapper(mapPoints)
   meshVertices$GetProperty()$SetColor(.3, 0,0)
   meshVertices$GetProperty()$SetOpacity(0.5)

vtkActor()->meshActor
    meshActor$SetMapper(mapMesh)
    meshActor$GetProperty()$SetColor(.1, .2, .4)
    meshActor$GetProperty()$SetOpacity(0.5)

vtkRenderer()->ren1
    ren1$AddActor(meshActor)
    ren1$AddActor(meshVertices)

vtkCubeAxesActor2D()->axes
    axes$SetProp(meshVertices)
    axes$SetFlyModeToOuterEdges()
    axes$ScalingOff()
    axes$SetCamera(ren1$GetActiveCamera())

    ren1$AddProp(axes)

.vtk$AddRenderer(ren1)


