#include <vtkObjectBase.h>
#include <vtkObject.h>
#include <vtkCommand.h>

extern "C" {
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"

class vtkRCommand : public vtkCommand
{
public:
  static vtkRCommand *New() { return new vtkRCommand; };
  void SetFunc(SEXP arg, SEXP env);
  void vtkRCommand::Execute(vtkObject *, unsigned long, void *);
 

  SEXP Environment;
  SEXP Func;
protected:
  vtkRCommand(){};
  ~vtkRCommand(); 
};
  
 void vtkRCommand::Execute(vtkObject *, unsigned long, void *){
   if (!((this->Func==NULL_USER_OBJECT)||(this->Environment==NULL_USER_OBJECT))){
     eval(this->Func,this->Environment);
   };
 }
 
  void vtkRCommand::SetFunc(SEXP arg, SEXP env){ 
    this->Func = arg; 
    this->Environment = env; 
    R_PreserveObject(this->Environment);
    R_PreserveObject(this->Func);
  } 

  vtkRCommand::~vtkRCommand(){
    R_ReleaseObject(this->Environment);
    R_ReleaseObject(this->Func);
  } 


  SEXP R_vtkObjectBase_New() {
    SEXP R_res = NULL_USER_OBJECT;
    vtkObjectBase * res=vtkObjectBase::New();
    R_res=toRPointer(res,"vtkObjectBase");
    return(R_res);
  }

  SEXP R_vtkObjectBase_GetClassName(SEXP R_obj) {
    SEXP R_res=NULL_USER_OBJECT;
    vtkObjectBase * obj = (vtkObjectBase *) getPtrValue(R_obj);
    char * res = (char *) obj->GetClassName();
    R_res = Rf_mkString(res);
    return(R_res);
  }

  SEXP R_vtkObjectBase_Delete(SEXP obj) {
    SEXP res = NULL_USER_OBJECT;  
    vtkObjectBase * _obj = (vtkObjectBase *) SexpToVtk(obj);
    _obj->Delete();
    return(res);
  }

  SEXP R_vtkObjectBase_Register(SEXP obj) {
    SEXP res = NULL_USER_OBJECT;  
    vtkObjectBase * _obj = (vtkObjectBase *) SexpToVtk(obj);
	_obj->Register(_obj);
    return(res);
  }

  SEXP R_vtkObjectBase_UnRegister(SEXP obj) {
    SEXP res = NULL_USER_OBJECT;  
    vtkObjectBase * _obj = (vtkObjectBase *) SexpToVtk(obj);
    _obj->UnRegister(_obj);
    return(res);
  }
  
  SEXP R_vtkObjectBase_GetReferenceCount(SEXP obj) {
    SEXP res = NULL_USER_OBJECT;  
    vtkObjectBase * _obj = (vtkObjectBase *) SexpToVtk(obj);
    int _res = _obj->GetReferenceCount();
    res=intToSexp(&_res,1);
    return(res);
  }

  SEXP R_vtkObject_GetClassName( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    char *  _res =( char * )_obj->GetClassName();
    res=charToSexp(_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_IsTypeOf( SEXP obj, SEXP type){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    int _res =_obj->IsTypeOf(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_IsA( SEXP obj, SEXP type){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    int _res =_obj->IsA(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_SafeDownCast( SEXP obj, SEXP o){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkObjectBase  *  _o = (vtkObjectBase * )  SexpToVtk(o);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    vtkObject *  _res =( vtkObject * )_obj->SafeDownCast(_o);
    res=VtkToSexp(_res,"vtkObject");
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_o,"vtkObjectBase"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".o",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_NewInstance( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    vtkObject *  _res =( vtkObject * )_obj->NewInstance();
    res=VtkToSexp(_res,"vtkObject");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_DebugOn( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->DebugOn();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_DebugOff( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->DebugOff();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_GetDebug( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    unsigned char _res =_obj->GetDebug();
    res=unsigned_charToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_SetDebug( SEXP obj, SEXP debugFlag){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     SET_LENGTH(debugFlag,1);
     unsigned char  *  _debugFlag =  SexpTounsigned_char(debugFlag);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->SetDebug( * _debugFlag);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_BreakOnError( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->BreakOnError();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_Modified( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->Modified();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_GetMTime( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    long unsigned int _res =_obj->GetMTime();
    res=long_unsigned_intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_SetGlobalWarningDisplay( SEXP obj, SEXP val){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     SET_LENGTH(val,1);
     int  *  _val =  SexpToint(val);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->SetGlobalWarningDisplay( * _val);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_GlobalWarningDisplayOn( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->GlobalWarningDisplayOn();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_GlobalWarningDisplayOff( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->GlobalWarningDisplayOff();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_GetGlobalWarningDisplay( SEXP obj){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    int _res =_obj->GetGlobalWarningDisplay();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_Register( SEXP obj, SEXP o){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkObjectBase  *  _o = (vtkObjectBase * )  SexpToVtk(o);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->Register(_o);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_o,"vtkObjectBase"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".o",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_UnRegister( SEXP obj, SEXP o){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkObjectBase  *  _o = (vtkObjectBase * )  SexpToVtk(o);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->UnRegister(_o);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_o,"vtkObjectBase"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".o",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_AddObserver( SEXP obj, SEXP event, SEXP cmd, SEXP env, SEXP p){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     SET_LENGTH(event,1);
     long unsigned int  *  _event =  SexpTolong_unsigned_int(event);
     vtkRCommand  *  _cmd = vtkRCommand::New();
     _cmd->SetFunc(cmd,env);
     SET_LENGTH(p,1);
     float  *  _p =  SexpTofloat(p);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    long unsigned int _res =_obj->AddObserver( * _event, _cmd,  * _p);
    _cmd->Delete();
    res=long_unsigned_intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_AddObserver_v1( SEXP obj, SEXP event, SEXP cmd, SEXP env, SEXP p){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     SET_LENGTH(event,1);
     char  *  _event =  SexpTochar(event);
     vtkRCommand  *  _cmd = vtkRCommand::New();
     _cmd->SetFunc(cmd,env);
     SET_LENGTH(p,1);
     float  *  _p =  SexpTofloat(p);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    long unsigned int _res =_obj->AddObserver(_event, _cmd,  * _p);
    res=long_unsigned_intToSexp(&_res,1);
    _cmd->Delete();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }

  SEXP R_vtkObject_RemoveObserver( SEXP obj, SEXP tag){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     SET_LENGTH(tag,1);
     long unsigned int  *  _tag =  SexpTolong_unsigned_int(tag);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->RemoveObserver( * _tag);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
    
  SEXP R_vtkObject_RemoveObservers( SEXP obj, SEXP event){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     SET_LENGTH(event,1);
     long unsigned int  *  _event =  SexpTolong_unsigned_int(event);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->RemoveObservers( * _event);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_RemoveObservers_v1( SEXP obj, SEXP event){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _event =  SexpTochar(event);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    _obj->RemoveObservers(_event);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_HasObserver( SEXP obj, SEXP event){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     SET_LENGTH(event,1);
     long unsigned int  *  _event =  SexpTolong_unsigned_int(event);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    int _res =_obj->HasObserver( * _event);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_HasObserver_v1( SEXP obj, SEXP event){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _event =  SexpTochar(event);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    int _res =_obj->HasObserver(_event);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 

  SEXP R_vtkObject_InvokeEvent( SEXP obj, SEXP event){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     SET_LENGTH(event,1);
     long unsigned int  *  _event =  SexpTolong_unsigned_int(event);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    int _res =_obj->InvokeEvent( * _event);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_InvokeEvent_v1( SEXP obj, SEXP event){
     int Counter;
     SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _event =  SexpTochar(event);
    vtkObject * _obj = (vtkObject * ) SexpToVtk(obj);
    int _res =_obj->InvokeEvent(_event);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkObject_New() {
    SEXP R_res = NULL_USER_OBJECT;
    vtkObject * res= ( vtkObject * ) vtkObject::New();
    R_res=toRPointer(res,"vtkObject");
    return(R_res);
  }

}


