#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>

#include "R_ext/Memory.h"
#include "R_ext/Boolean.h"
#define CHAR_DEREF(x)   CHAR((x))
#define IS_FUNCTION(x)   isFunction((x))
typedef SEXP USER_OBJECT_;
typedef int RSInt;
extern void RVoidFunc(void *);
extern void * RVoidPointerFunc(void *);
extern void RVoidFuncArgDelete(void *);
typedef struct _RvoidFuncArg 
{
  SEXP func;
  SEXP env;
} RVoidFuncArg;



USER_OBJECT_ asRLogical(Rboolean val);
USER_OBJECT_ asRInt(int val);
USER_OBJECT_ asRCharacter(const char *val);
USER_OBJECT_ asRNumeric(double val);
USER_OBJECT_ toRPointer(void *val, const char *type);
void * getPtrValue(USER_OBJECT_ sval);
char ** asCStringArray(USER_OBJECT_ svec);

void * SexpToVtk(USER_OBJECT_ sval);
SEXP VtkToSexp(void *val, const char *type);

double * SexpTodouble(USER_OBJECT_ svec);
SEXP doubleToSexp(double * d, int dims);

char * SexpTochar(USER_OBJECT_ svec);
SEXP charToSexp(char * val,int unused);

int * SexpToint(USER_OBJECT_ svec);
SEXP intToSexp(int * d, int dims);

float * SexpTofloat(USER_OBJECT_ svec);
SEXP floatToSexp(float * d, int dims);

long int * SexpTolong_int(USER_OBJECT_ svec);
SEXP long_intToSexp(long int * d, int dims);

long long int * SexpTolong_long_int(USER_OBJECT_ svec);
SEXP long_long_intToSexp(long long int * d, int dims);

long long unsigned int * SexpTolong_long_unsigned_int(USER_OBJECT_ svec);
SEXP long_long_unsigned_intToSexp(long long unsigned int * d, int dims);

unsigned int * SexpTounsigned_int(USER_OBJECT_ svec);
SEXP unsigned_intToSexp(unsigned int * d, int dims);

SEXP long_unsigned_intToSexp(long unsigned int * d, int dims);
long unsigned int * SexpTolong_unsigned_int(USER_OBJECT_ svec);

SEXP voidToSexp(void * x,int unused);
void * SexpTovoid(SEXP z);

SEXP unsigned_charToSexp(unsigned char * d, int dims);
unsigned char * SexpTounsigned_char(USER_OBJECT_ svec);

SEXP signed_charToSexp(signed char * d, int dims);
signed char * SexpTosigned_char(USER_OBJECT_ svec);


short unsigned int * SexpToshort_unsigned_int(USER_OBJECT_ svec);
SEXP short_unsigned_intToSexp(short unsigned int * d, int dims);

short int * SexpToshort_int(USER_OBJECT_ svec);
SEXP short_intToSexp(short int * d, int dims);
//void init_answer(SEXP Ans, SEXP Names, int length);
//void add_answer(SEXP Ans, SEXP Names, SEXP El, char * name,int pos);
//void complete_answer(SEXP Ans, SEXP Names);

SEXP toRList(SEXP * Ans, char** names, int length);
