#include <vtkCell.h>
extern "C" {
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"
#ifdef R_VTK_BASE
  SEXP R_vtkCell_IsTypeOf( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->IsTypeOf(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_IsA( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->IsA(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_SafeDownCast( SEXP obj, SEXP o){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkObjectBase  *  _o = (vtkObjectBase * )  SexpToVtk(o);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    vtkCell *  _res =( vtkCell * )_obj->SafeDownCast(_o);
    res=VtkToSexp(_res,"vtkCell");
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_o,"vtkObjectBase"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".o",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_NewInstance( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    vtkCell *  _res =( vtkCell * )_obj->NewInstance();
    res=VtkToSexp(_res,"vtkCell");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_Initialize( SEXP obj, SEXP npts, SEXP pts, SEXP p){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(npts,1);
     int  *  _npts =  SexpToint(npts);
     int  *  _pts =  SexpToint(pts);
     vtkPoints  *  _p = (vtkPoints * )  SexpToVtk(p);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->Initialize( * _npts, _pts, _p);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,intToSexp(_pts,LENGTH(pts)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".pts",0));
    SET_VECTOR_ELT(ans,2,VtkToSexp(_p,"vtkPoints"));
    SET_VECTOR_ELT(res_names,2,charToSexp(".p",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_ShallowCopy( SEXP obj, SEXP c){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkCell  *  _c = (vtkCell * )  SexpToVtk(c);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->ShallowCopy(_c);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_c,"vtkCell"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".c",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_DeepCopy( SEXP obj, SEXP c){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkCell  *  _c = (vtkCell * )  SexpToVtk(c);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->DeepCopy(_c);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_c,"vtkCell"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".c",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetCellType( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->GetCellType();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetCellDimension( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->GetCellDimension();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_IsLinear( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->IsLinear();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_RequiresInitialization( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->RequiresInitialization();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_Initialize_v1( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->Initialize();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_IsExplicitCell( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->IsExplicitCell();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetPoints( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    vtkPoints *  _res =( vtkPoints * )_obj->GetPoints();
    res=VtkToSexp(_res,"vtkPoints");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetNumberOfPoints( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->GetNumberOfPoints();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetNumberOfEdges( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->GetNumberOfEdges();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetNumberOfFaces( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->GetNumberOfFaces();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetPointIds( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    vtkIdList *  _res =( vtkIdList * )_obj->GetPointIds();
    res=VtkToSexp(_res,"vtkIdList");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetPointId( SEXP obj, SEXP ptId){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(ptId,1);
     int  *  _ptId =  SexpToint(ptId);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->GetPointId( * _ptId);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetEdge( SEXP obj, SEXP edgeId){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(edgeId,1);
     int  *  _edgeId =  SexpToint(edgeId);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    vtkCell *  _res =( vtkCell * )_obj->GetEdge( * _edgeId);
    res=VtkToSexp(_res,"vtkCell");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetFace( SEXP obj, SEXP faceId){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(faceId,1);
     int  *  _faceId =  SexpToint(faceId);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    vtkCell *  _res =( vtkCell * )_obj->GetFace( * _faceId);
    res=VtkToSexp(_res,"vtkCell");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_CellBoundary( SEXP obj, SEXP subId, SEXP pcoords, SEXP pts){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(subId,1);
     int  *  _subId =  SexpToint(subId);
    SET_LENGTH(pcoords,3);
     double  *  _pcoords =  SexpTodouble(pcoords);
     vtkIdList  *  _pts = (vtkIdList * )  SexpToVtk(pts);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->CellBoundary( * _subId, _pcoords, _pts);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_pcoords,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".pcoords",0));
    SET_VECTOR_ELT(ans,2,VtkToSexp(_pts,"vtkIdList"));
    SET_VECTOR_ELT(res_names,2,charToSexp(".pts",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_EvaluatePosition( SEXP obj, SEXP x, SEXP closestPoint, SEXP subId, SEXP pcoords, SEXP dist2, SEXP weights){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(x,3);
     double  *  _x =  SexpTodouble(x);
     double  *  _closestPoint =  SexpTodouble(closestPoint);
    SET_LENGTH(subId,1);
     int  *  _subId =  SexpToint(subId);
    SET_LENGTH(pcoords,3);
     double  *  _pcoords =  SexpTodouble(pcoords);
    SET_LENGTH(dist2,1);
     double  *  _dist2 =  SexpTodouble(dist2);
     double  *  _weights =  SexpTodouble(weights);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->EvaluatePosition(_x, _closestPoint,  * _subId, _pcoords,  * _dist2, _weights);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,7));
    PROTECT(res_names = allocVector(VECSXP,7));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_x,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".x",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_closestPoint,LENGTH(closestPoint)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".closestPoint",0));
    SET_VECTOR_ELT(ans,3,intToSexp(_subId,1));
    SET_VECTOR_ELT(res_names,3,charToSexp(".subId",0));
    SET_VECTOR_ELT(ans,4,doubleToSexp(_pcoords,3));
    SET_VECTOR_ELT(res_names,4,charToSexp(".pcoords",0));
    SET_VECTOR_ELT(ans,5,doubleToSexp(_dist2,1));
    SET_VECTOR_ELT(res_names,5,charToSexp(".dist2",0));
    SET_VECTOR_ELT(ans,6,doubleToSexp(_weights,LENGTH(weights)));
    SET_VECTOR_ELT(res_names,6,charToSexp(".weights",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_EvaluateLocation( SEXP obj, SEXP subId, SEXP pcoords, SEXP x, SEXP weights){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(subId,1);
     int  *  _subId =  SexpToint(subId);
    SET_LENGTH(pcoords,3);
     double  *  _pcoords =  SexpTodouble(pcoords);
    SET_LENGTH(x,3);
     double  *  _x =  SexpTodouble(x);
     double  *  _weights =  SexpTodouble(weights);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->EvaluateLocation( * _subId, _pcoords, _x, _weights);
    PROTECT(ans = allocVector(VECSXP,5));
    PROTECT(res_names = allocVector(VECSXP,5));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,intToSexp(_subId,1));
    SET_VECTOR_ELT(res_names,1,charToSexp(".subId",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_pcoords,3));
    SET_VECTOR_ELT(res_names,2,charToSexp(".pcoords",0));
    SET_VECTOR_ELT(ans,3,doubleToSexp(_x,3));
    SET_VECTOR_ELT(res_names,3,charToSexp(".x",0));
    SET_VECTOR_ELT(ans,4,doubleToSexp(_weights,LENGTH(weights)));
    SET_VECTOR_ELT(res_names,4,charToSexp(".weights",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_Contour( SEXP obj, SEXP value, SEXP cellScalars, SEXP locator, SEXP verts, SEXP lines, SEXP polys, SEXP inPd, SEXP outPd, SEXP inCd, SEXP cellId, SEXP outCd){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(value,1);
     double  *  _value =  SexpTodouble(value);
     vtkDataArray  *  _cellScalars = (vtkDataArray * )  SexpToVtk(cellScalars);
     vtkPointLocator  *  _locator = (vtkPointLocator * )  SexpToVtk(locator);
     vtkCellArray  *  _verts = (vtkCellArray * )  SexpToVtk(verts);
     vtkCellArray  *  _lines = (vtkCellArray * )  SexpToVtk(lines);
     vtkCellArray  *  _polys = (vtkCellArray * )  SexpToVtk(polys);
     vtkPointData  *  _inPd = (vtkPointData * )  SexpToVtk(inPd);
     vtkPointData  *  _outPd = (vtkPointData * )  SexpToVtk(outPd);
     vtkCellData  *  _inCd = (vtkCellData * )  SexpToVtk(inCd);
    SET_LENGTH(cellId,1);
     int  *  _cellId =  SexpToint(cellId);
     vtkCellData  *  _outCd = (vtkCellData * )  SexpToVtk(outCd);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->Contour( * _value, _cellScalars, _locator, _verts, _lines, _polys, _inPd, _outPd, _inCd,  * _cellId, _outCd);
    PROTECT(ans = allocVector(VECSXP,10));
    PROTECT(res_names = allocVector(VECSXP,10));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_cellScalars,"vtkDataArray"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".cellScalars",0));
    SET_VECTOR_ELT(ans,2,VtkToSexp(_locator,"vtkPointLocator"));
    SET_VECTOR_ELT(res_names,2,charToSexp(".locator",0));
    SET_VECTOR_ELT(ans,3,VtkToSexp(_verts,"vtkCellArray"));
    SET_VECTOR_ELT(res_names,3,charToSexp(".verts",0));
    SET_VECTOR_ELT(ans,4,VtkToSexp(_lines,"vtkCellArray"));
    SET_VECTOR_ELT(res_names,4,charToSexp(".lines",0));
    SET_VECTOR_ELT(ans,5,VtkToSexp(_polys,"vtkCellArray"));
    SET_VECTOR_ELT(res_names,5,charToSexp(".polys",0));
    SET_VECTOR_ELT(ans,6,VtkToSexp(_inPd,"vtkPointData"));
    SET_VECTOR_ELT(res_names,6,charToSexp(".inPd",0));
    SET_VECTOR_ELT(ans,7,VtkToSexp(_outPd,"vtkPointData"));
    SET_VECTOR_ELT(res_names,7,charToSexp(".outPd",0));
    SET_VECTOR_ELT(ans,8,VtkToSexp(_inCd,"vtkCellData"));
    SET_VECTOR_ELT(res_names,8,charToSexp(".inCd",0));
    SET_VECTOR_ELT(ans,9,VtkToSexp(_outCd,"vtkCellData"));
    SET_VECTOR_ELT(res_names,9,charToSexp(".outCd",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_Clip( SEXP obj, SEXP value, SEXP cellScalars, SEXP locator, SEXP connectivity, SEXP inPd, SEXP outPd, SEXP inCd, SEXP cellId, SEXP outCd, SEXP insideOut){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(value,1);
     double  *  _value =  SexpTodouble(value);
     vtkDataArray  *  _cellScalars = (vtkDataArray * )  SexpToVtk(cellScalars);
     vtkPointLocator  *  _locator = (vtkPointLocator * )  SexpToVtk(locator);
     vtkCellArray  *  _connectivity = (vtkCellArray * )  
SexpToVtk(connectivity);
     vtkPointData  *  _inPd = (vtkPointData * )  SexpToVtk(inPd);
     vtkPointData  *  _outPd = (vtkPointData * )  SexpToVtk(outPd);
     vtkCellData  *  _inCd = (vtkCellData * )  SexpToVtk(inCd);
    SET_LENGTH(cellId,1);
     int  *  _cellId =  SexpToint(cellId);
     vtkCellData  *  _outCd = (vtkCellData * )  SexpToVtk(outCd);
    SET_LENGTH(insideOut,1);
     int  *  _insideOut =  SexpToint(insideOut);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->Clip( * _value, _cellScalars, _locator, _connectivity, _inPd, _outPd, _inCd,  * _cellId, _outCd,  * _insideOut);
    PROTECT(ans = allocVector(VECSXP,8));
    PROTECT(res_names = allocVector(VECSXP,8));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_cellScalars,"vtkDataArray"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".cellScalars",0));
    SET_VECTOR_ELT(ans,2,VtkToSexp(_locator,"vtkPointLocator"));
    SET_VECTOR_ELT(res_names,2,charToSexp(".locator",0));
    SET_VECTOR_ELT(ans,3,VtkToSexp(_connectivity,"vtkCellArray"));
    SET_VECTOR_ELT(res_names,3,charToSexp(".connectivity",0));
    SET_VECTOR_ELT(ans,4,VtkToSexp(_inPd,"vtkPointData"));
    SET_VECTOR_ELT(res_names,4,charToSexp(".inPd",0));
    SET_VECTOR_ELT(ans,5,VtkToSexp(_outPd,"vtkPointData"));
    SET_VECTOR_ELT(res_names,5,charToSexp(".outPd",0));
    SET_VECTOR_ELT(ans,6,VtkToSexp(_inCd,"vtkCellData"));
    SET_VECTOR_ELT(res_names,6,charToSexp(".inCd",0));
    SET_VECTOR_ELT(ans,7,VtkToSexp(_outCd,"vtkCellData"));
    SET_VECTOR_ELT(res_names,7,charToSexp(".outCd",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_IntersectWithLine( SEXP obj, SEXP p1, SEXP p2, SEXP tol, SEXP t, SEXP x, SEXP pcoords, SEXP subId){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(p1,3);
     double  *  _p1 =  SexpTodouble(p1);
    SET_LENGTH(p2,3);
     double  *  _p2 =  SexpTodouble(p2);
    SET_LENGTH(tol,1);
     double  *  _tol =  SexpTodouble(tol);
    SET_LENGTH(t,1);
     double  *  _t =  SexpTodouble(t);
    SET_LENGTH(x,3);
     double  *  _x =  SexpTodouble(x);
    SET_LENGTH(pcoords,3);
     double  *  _pcoords =  SexpTodouble(pcoords);
    SET_LENGTH(subId,1);
     int  *  _subId =  SexpToint(subId);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->IntersectWithLine(_p1, _p2,  * _tol,  * _t, _x, _pcoords,  * _subId);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,7));
    PROTECT(res_names = allocVector(VECSXP,7));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_p1,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".p1",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_p2,3));
    SET_VECTOR_ELT(res_names,2,charToSexp(".p2",0));
    SET_VECTOR_ELT(ans,3,doubleToSexp(_t,1));
    SET_VECTOR_ELT(res_names,3,charToSexp(".t",0));
    SET_VECTOR_ELT(ans,4,doubleToSexp(_x,3));
    SET_VECTOR_ELT(res_names,4,charToSexp(".x",0));
    SET_VECTOR_ELT(ans,5,doubleToSexp(_pcoords,3));
    SET_VECTOR_ELT(res_names,5,charToSexp(".pcoords",0));
    SET_VECTOR_ELT(ans,6,intToSexp(_subId,1));
    SET_VECTOR_ELT(res_names,6,charToSexp(".subId",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_Triangulate( SEXP obj, SEXP index, SEXP ptIds, SEXP pts){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(index,1);
     int  *  _index =  SexpToint(index);
     vtkIdList  *  _ptIds = (vtkIdList * )  SexpToVtk(ptIds);
     vtkPoints  *  _pts = (vtkPoints * )  SexpToVtk(pts);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->Triangulate( * _index, _ptIds, _pts);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_ptIds,"vtkIdList"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".ptIds",0));
    SET_VECTOR_ELT(ans,2,VtkToSexp(_pts,"vtkPoints"));
    SET_VECTOR_ELT(res_names,2,charToSexp(".pts",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_Derivatives( SEXP obj, SEXP subId, SEXP pcoords, SEXP values, SEXP dim, SEXP derivs){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(subId,1);
     int  *  _subId =  SexpToint(subId);
    SET_LENGTH(pcoords,3);
     double  *  _pcoords =  SexpTodouble(pcoords);
     double  *  _values =  SexpTodouble(values);
    SET_LENGTH(dim,1);
     int  *  _dim =  SexpToint(dim);
     double  *  _derivs =  SexpTodouble(derivs);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->Derivatives( * _subId, _pcoords, _values,  * _dim, _derivs);
    PROTECT(ans = allocVector(VECSXP,4));
    PROTECT(res_names = allocVector(VECSXP,4));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_pcoords,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".pcoords",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_values,LENGTH(values)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".values",0));
    SET_VECTOR_ELT(ans,3,doubleToSexp(_derivs,LENGTH(derivs)));
    SET_VECTOR_ELT(res_names,3,charToSexp(".derivs",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetBounds( SEXP obj, SEXP bounds){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(bounds,6);
     double  *  _bounds =  SexpTodouble(bounds);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    _obj->GetBounds(_bounds);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_bounds,6));
    SET_VECTOR_ELT(res_names,1,charToSexp(".bounds",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetBounds_v1( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    double *  _res =( double * )_obj->GetBounds();
    res=doubleToSexp(_res,6);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetLength2( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    double _res =_obj->GetLength2();
    res=doubleToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetParametricCenter( SEXP obj, SEXP pcoords){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(pcoords,3);
     double  *  _pcoords =  SexpTodouble(pcoords);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->GetParametricCenter(_pcoords);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_pcoords,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".pcoords",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetParametricDistance( SEXP obj, SEXP pcoords){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(pcoords,3);
     double  *  _pcoords =  SexpTodouble(pcoords);
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    double _res =_obj->GetParametricDistance(_pcoords);
    res=doubleToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_pcoords,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".pcoords",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_IsPrimaryCell( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    int _res =_obj->IsPrimaryCell();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkCell_GetParametricCoords( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkCell * _obj = (vtkCell * ) SexpToVtk(obj);
    double *  _res =( double * )_obj->GetParametricCoords();
    res=doubleToSexp(_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
#endif
}
