#include <vtk/vtkDataArray.h>

extern "C" {

#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"

 SEXP R_vtkDataArray_SetArrayData(SEXP obj, SEXP x, SEXP y, SEXP value) {
    SEXP R_res=NULL_USER_OBJECT;
   int * _x = SexpToint(x);
   int xl=LENGTH(x);
   int * _y = SexpToint(y);
   int yl=LENGTH(y);
   double * _value=SexpTodouble(value);
   int ix,iy;
   double temp0;
   vtkDataArray * _obj=(vtkDataArray *) SexpToVtk(obj);
    for (ix=0;ix<xl;ix++){
     for (iy=0;iy<yl;iy++){
       temp0=*(_value+ix+iy*xl);
       _obj->SetComponent(_x[ix]-1,_y[iy]-1,temp0);
     }
    }
    return(R_res);
 }

 SEXP R_vtkDataArray_GetArrayData(SEXP obj, SEXP x, SEXP y) {
   int * _x = SexpToint(x);
   int xl=LENGTH(x);
   int * _y = SexpToint(y);
   int yl=LENGTH(y);
   double * _value=(double *) R_alloc(xl*yl,sizeof(double));
   int ix,iy;
   double temp0;
   vtkDataArray * _obj=(vtkDataArray *) SexpToVtk(obj);
    for (ix=0;ix<xl;ix++){
     for (iy=0;iy<yl;iy++){
       temp0=_obj->GetComponent(_x[ix]-1,_y[iy]-1);
       *(_value+ix+iy*xl)=temp0;
     }
    }
    return(doubleToSexp(_value,xl*yl));
 }


}
