#include <vtkExodusModel.h>
extern "C" {
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"
#ifdef R_VTK_HYBRID
  SEXP R_vtkExodusModel_IsTypeOf( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->IsTypeOf(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_IsA( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->IsA(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_SafeDownCast( SEXP obj, SEXP o){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkObjectBase  *  _o = (vtkObjectBase * )  SexpToVtk(o);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    vtkExodusModel *  _res =( vtkExodusModel * )_obj->SafeDownCast(_o);
    res=VtkToSexp(_res,"vtkExodusModel");
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_o,"vtkObjectBase"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".o",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_NewInstance( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    vtkExodusModel *  _res =( vtkExodusModel * )_obj->NewInstance();
    res=VtkToSexp(_res,"vtkExodusModel");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_SetGlobalInformation( SEXP obj, SEXP fid, SEXP compute_word_size){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(fid,1);
     int  *  _fid =  SexpToint(fid);
    SET_LENGTH(compute_word_size,1);
     int  *  _compute_word_size =  SexpToint(compute_word_size);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->SetGlobalInformation( * _fid,  * _compute_word_size);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_AddUGridElementVariable( SEXP obj, SEXP ugridVarName, SEXP origName, SEXP numComponents){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _ugridVarName =  SexpTochar(ugridVarName);
     char  *  _origName =  SexpTochar(origName);
    SET_LENGTH(numComponents,1);
     int  *  _numComponents =  SexpToint(numComponents);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->AddUGridElementVariable(_ugridVarName, _origName,  * _numComponents);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,charToSexp(_ugridVarName,LENGTH(ugridVarName)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".ugridVarName",0));
    SET_VECTOR_ELT(ans,2,charToSexp(_origName,LENGTH(origName)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".origName",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_RemoveUGridElementVariable( SEXP obj, SEXP ugridVarName){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _ugridVarName =  SexpTochar(ugridVarName);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->RemoveUGridElementVariable(_ugridVarName);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,charToSexp(_ugridVarName,LENGTH(ugridVarName)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".ugridVarName",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_AddUGridNodeVariable( SEXP obj, SEXP ugridVarName, SEXP origName, SEXP numComponents){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _ugridVarName =  SexpTochar(ugridVarName);
     char  *  _origName =  SexpTochar(origName);
    SET_LENGTH(numComponents,1);
     int  *  _numComponents =  SexpToint(numComponents);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->AddUGridNodeVariable(_ugridVarName, _origName,  * _numComponents);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,charToSexp(_ugridVarName,LENGTH(ugridVarName)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".ugridVarName",0));
    SET_VECTOR_ELT(ans,2,charToSexp(_origName,LENGTH(origName)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".origName",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_RemoveUGridNodeVariable( SEXP obj, SEXP ugridVarName){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _ugridVarName =  SexpTochar(ugridVarName);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->RemoveUGridNodeVariable(_ugridVarName);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,charToSexp(_ugridVarName,LENGTH(ugridVarName)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".ugridVarName",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_SetLocalInformation( SEXP obj, SEXP ugrid, SEXP fid, SEXP timeStep, SEXP geoCount, SEXP compute_word_size){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkUnstructuredGrid  *  _ugrid = (vtkUnstructuredGrid * )  
SexpToVtk(ugrid);
    SET_LENGTH(fid,1);
     int  *  _fid =  SexpToint(fid);
    SET_LENGTH(timeStep,1);
     int  *  _timeStep =  SexpToint(timeStep);
    SET_LENGTH(geoCount,1);
     int  *  _geoCount =  SexpToint(geoCount);
    SET_LENGTH(compute_word_size,1);
     int  *  _compute_word_size =  SexpToint(compute_word_size);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->SetLocalInformation(_ugrid,  * _fid,  * _timeStep,  * _geoCount,  * _compute_word_size);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_ugrid,"vtkUnstructuredGrid"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".ugrid",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_HasMetadata( SEXP obj, SEXP grid){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkUnstructuredGrid  *  _grid = (vtkUnstructuredGrid * )  SexpToVtk(grid);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->HasMetadata(_grid);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_grid,"vtkUnstructuredGrid"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".grid",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_GetModelMetadata( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    vtkModelMetadata *  _res =( vtkModelMetadata * )_obj->GetModelMetadata();
    res=VtkToSexp(_res,"vtkModelMetadata");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_SetModelMetadata( SEXP obj, SEXP emd){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkModelMetadata  *  _emd = (vtkModelMetadata * )  SexpToVtk(emd);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    _obj->SetModelMetadata(_emd);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_emd,"vtkModelMetadata"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".emd",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_UnpackExodusModel( SEXP obj, SEXP grid, SEXP deleteIt){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkUnstructuredGrid  *  _grid = (vtkUnstructuredGrid * )  SexpToVtk(grid);
    SET_LENGTH(deleteIt,1);
     int  *  _deleteIt =  SexpToint(deleteIt);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->UnpackExodusModel(_grid,  * _deleteIt);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_grid,"vtkUnstructuredGrid"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".grid",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_MergeExodusModel( SEXP obj, SEXP em){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkExodusModel  *  _em = (vtkExodusModel * )  SexpToVtk(em);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    int _res =_obj->MergeExodusModel(_em);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_em,"vtkExodusModel"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".em",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_ExtractExodusModel( SEXP obj, SEXP globalCellIdList, SEXP grid, SEXP globalCellIdArrayName, SEXP globalNodeIdArrayName){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkIntArray  *  _globalCellIdList = (vtkIntArray * )  
SexpToVtk(globalCellIdList);
     vtkUnstructuredGrid  *  _grid = (vtkUnstructuredGrid * )  SexpToVtk(grid);
     char  *  _globalCellIdArrayName =  SexpTochar(globalCellIdArrayName);
     char  *  _globalNodeIdArrayName =  SexpTochar(globalNodeIdArrayName);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    vtkExodusModel *  _res =( vtkExodusModel * )_obj->ExtractExodusModel(_globalCellIdList, _grid, _globalCellIdArrayName, _globalNodeIdArrayName);
    res=VtkToSexp(_res,"vtkExodusModel");
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_globalCellIdList,"vtkIntArray"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".globalCellIdList",0));
    SET_VECTOR_ELT(ans,2,VtkToSexp(_grid,"vtkUnstructuredGrid"));
    SET_VECTOR_ELT(res_names,2,charToSexp(".grid",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_PackExodusModel( SEXP obj, SEXP grid){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkUnstructuredGrid  *  _grid = (vtkUnstructuredGrid * )  SexpToVtk(grid);
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    _obj->PackExodusModel(_grid);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_grid,"vtkUnstructuredGrid"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".grid",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_Reset( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkExodusModel * _obj = (vtkExodusModel * ) SexpToVtk(obj);
    _obj->Reset();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkExodusModel_New() {
    SEXP R_res = NULL_USER_OBJECT;
    vtkExodusModel * res= ( vtkExodusModel * ) vtkExodusModel::New();
    R_res=toRPointer(res,"vtkExodusModel");
    return(R_res);
  }
#endif
}
