#include <vtkHull.h>
extern "C" {
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"
#ifdef R_VTK_BASE
  SEXP R_vtkHull_IsTypeOf( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    int _res =_obj->IsTypeOf(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_IsA( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    int _res =_obj->IsA(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_SafeDownCast( SEXP obj, SEXP o){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkObjectBase  *  _o = (vtkObjectBase * )  SexpToVtk(o);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    vtkHull *  _res =( vtkHull * )_obj->SafeDownCast(_o);
    res=VtkToSexp(_res,"vtkHull");
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_o,"vtkObjectBase"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".o",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_NewInstance( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    vtkHull *  _res =( vtkHull * )_obj->NewInstance();
    res=VtkToSexp(_res,"vtkHull");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_RemoveAllPlanes( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->RemoveAllPlanes();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_AddPlane( SEXP obj, SEXP A, SEXP B, SEXP C){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(A,1);
     double  *  _A =  SexpTodouble(A);
    SET_LENGTH(B,1);
     double  *  _B =  SexpTodouble(B);
    SET_LENGTH(C,1);
     double  *  _C =  SexpTodouble(C);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    int _res =_obj->AddPlane( * _A,  * _B,  * _C);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_AddPlane_v1( SEXP obj, SEXP plane){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(plane,3);
     double  *  _plane =  SexpTodouble(plane);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    int _res =_obj->AddPlane(_plane);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_plane,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".plane",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_SetPlane( SEXP obj, SEXP i, SEXP A, SEXP B, SEXP C){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(i,1);
     int  *  _i =  SexpToint(i);
    SET_LENGTH(A,1);
     double  *  _A =  SexpTodouble(A);
    SET_LENGTH(B,1);
     double  *  _B =  SexpTodouble(B);
    SET_LENGTH(C,1);
     double  *  _C =  SexpTodouble(C);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->SetPlane( * _i,  * _A,  * _B,  * _C);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_SetPlane_v1( SEXP obj, SEXP i, SEXP plane){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(i,1);
     int  *  _i =  SexpToint(i);
    SET_LENGTH(plane,3);
     double  *  _plane =  SexpTodouble(plane);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->SetPlane( * _i, _plane);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_plane,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".plane",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_AddPlane_v2( SEXP obj, SEXP A, SEXP B, SEXP C, SEXP D){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(A,1);
     double  *  _A =  SexpTodouble(A);
    SET_LENGTH(B,1);
     double  *  _B =  SexpTodouble(B);
    SET_LENGTH(C,1);
     double  *  _C =  SexpTodouble(C);
    SET_LENGTH(D,1);
     double  *  _D =  SexpTodouble(D);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    int _res =_obj->AddPlane( * _A,  * _B,  * _C,  * _D);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_AddPlane_v3( SEXP obj, SEXP plane, SEXP D){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(plane,3);
     double  *  _plane =  SexpTodouble(plane);
    SET_LENGTH(D,1);
     double  *  _D =  SexpTodouble(D);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    int _res =_obj->AddPlane(_plane,  * _D);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_plane,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".plane",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_SetPlane_v2( SEXP obj, SEXP i, SEXP A, SEXP B, SEXP C, SEXP D){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(i,1);
     int  *  _i =  SexpToint(i);
    SET_LENGTH(A,1);
     double  *  _A =  SexpTodouble(A);
    SET_LENGTH(B,1);
     double  *  _B =  SexpTodouble(B);
    SET_LENGTH(C,1);
     double  *  _C =  SexpTodouble(C);
    SET_LENGTH(D,1);
     double  *  _D =  SexpTodouble(D);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->SetPlane( * _i,  * _A,  * _B,  * _C,  * _D);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_SetPlane_v3( SEXP obj, SEXP i, SEXP plane, SEXP D){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(i,1);
     int  *  _i =  SexpToint(i);
    SET_LENGTH(plane,3);
     double  *  _plane =  SexpTodouble(plane);
    SET_LENGTH(D,1);
     double  *  _D =  SexpTodouble(D);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->SetPlane( * _i, _plane,  * _D);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_plane,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".plane",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_SetPlanes( SEXP obj, SEXP planes){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkPlanes  *  _planes = (vtkPlanes * )  SexpToVtk(planes);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->SetPlanes(_planes);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_planes,"vtkPlanes"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".planes",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_GetNumberOfPlanes( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    int _res =_obj->GetNumberOfPlanes();
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_AddCubeVertexPlanes( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->AddCubeVertexPlanes();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_AddCubeEdgePlanes( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->AddCubeEdgePlanes();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_AddCubeFacePlanes( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->AddCubeFacePlanes();
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_AddRecursiveSpherePlanes( SEXP obj, SEXP level){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(level,1);
     int  *  _level =  SexpToint(level);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->AddRecursiveSpherePlanes( * _level);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_GenerateHull( SEXP obj, SEXP pd, SEXP bounds){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkPolyData  *  _pd = (vtkPolyData * )  SexpToVtk(pd);
     double  *  _bounds =  SexpTodouble(bounds);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->GenerateHull(_pd, _bounds);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_pd,"vtkPolyData"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".pd",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_bounds,LENGTH(bounds)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".bounds",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_GenerateHull_v1( SEXP obj, SEXP pd, SEXP xmin, SEXP xmax, SEXP ymin, SEXP ymax, SEXP zmin, SEXP zmax){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkPolyData  *  _pd = (vtkPolyData * )  SexpToVtk(pd);
    SET_LENGTH(xmin,1);
     double  *  _xmin =  SexpTodouble(xmin);
    SET_LENGTH(xmax,1);
     double  *  _xmax =  SexpTodouble(xmax);
    SET_LENGTH(ymin,1);
     double  *  _ymin =  SexpTodouble(ymin);
    SET_LENGTH(ymax,1);
     double  *  _ymax =  SexpTodouble(ymax);
    SET_LENGTH(zmin,1);
     double  *  _zmin =  SexpTodouble(zmin);
    SET_LENGTH(zmax,1);
     double  *  _zmax =  SexpTodouble(zmax);
    vtkHull * _obj = (vtkHull * ) SexpToVtk(obj);
    _obj->GenerateHull(_pd,  * _xmin,  * _xmax,  * _ymin,  * _ymax,  * _zmin,  * _zmax);
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_pd,"vtkPolyData"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".pd",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkHull_New() {
    SEXP R_res = NULL_USER_OBJECT;
    vtkHull * res= ( vtkHull * ) vtkHull::New();
    R_res=toRPointer(res,"vtkHull");
    return(R_res);
  }
#endif
}
