#include <vtk/vtkImageData.h>

extern "C" {
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"


 SEXP R_vtkSetDataImage(SEXP obj, SEXP x, SEXP y, SEXP z, SEXP c, SEXP value, SEXP incs) {
   SEXP R_res=NULL_USER_OBJECT;
   int * i=SexpToint(incs);
   double * _value=SexpTodouble(value);
   int xl=LENGTH(x);
   int *_x=SexpToint(x);
   int yl=LENGTH(y);
   int * _y=SexpToint(y);
   int zl=LENGTH(z);
   int *_z=SexpToint(z);
   int cl=LENGTH(c);
   int * _c=SexpToint(c);
   int ix,iy,iz,ic;
   double temp0;
   vtkImageData * _obj=(vtkImageData *) SexpToVtk(obj);
   double * data=(double*)_obj->GetScalarPointer(0,0,0);
   for (ix=0;ix<xl;ix++){
     for (iy=0;iy<yl;iy++){
       for (iz=0;iz<zl;iz++){
	 for (ic=0;ic<cl;ic++){
	   temp0=*(_value+ix+iy*xl+iz*xl*yl+ic*xl*yl*zl);
	   *(data+(_x[ix]-1)*i[0]+(_y[iy]-1)*i[1]+(_z[iz]-1)*i[2]+(_c[ic]-1))= temp0;
	 };
       };
     };
   }
   return(R_res);
  }

SEXP R_vtkGetDataImage(SEXP obj, SEXP x, SEXP y, SEXP z, SEXP c, SEXP incs) {
   SEXP R_res=NULL_USER_OBJECT;
   int * i=SexpToint(incs);;

   int xl=LENGTH(x);
   int *_x=SexpToint(x);
   int yl=LENGTH(y);
   int * _y=SexpToint(y);
   int zl=LENGTH(z);
   int *_z=SexpToint(z);
   int cl=LENGTH(c);
   int * _c=SexpToint(c);
   void * data;
   int ix,iy,iz,ic;
   double temp0;
   double * _value=(double *) R_alloc(xl*yl*zl*cl,sizeof(double));
   vtkImageData * _obj=(vtkImageData *) SexpToVtk(obj);
   data=_obj->GetScalarPointer(0,0,0);
   for (ix=0;ix<xl;ix++){
     for (iy=0;iy<yl;iy++){
       for (iz=0;iz<zl;iz++){
	 for (ic=0;ic<cl;ic++){
	   switch(_obj->GetScalarType()){
	   case 3:{
	     unsigned char temp0;
	     temp0=*((unsigned char *) data+(_x[ix]-1)*i[0]+(_y[iy]-1)*i[1]+(_z[iz]-1)*i[2]+(_c[ic]-1));
		*(_value+ix+iy*xl+iz*xl*yl+ic*xl*yl*zl)=(double)temp0;
	   };break;
	   default:
	     {
	     double temp0;
		temp0=*((double *)data+(_x[ix]-1)*i[0]+(_y[iy]-1)*i[1]+(_z[iz]-1)*i[2]+(_c[ic]-1));
		*(_value+ix+iy*xl+iz*xl*yl+ic*xl*yl*zl)=(double)temp0;
	   };break;
	    
	   };
	 };
       };
     };
   };
   
   return(doubleToSexp(_value,xl*yl*zl*cl));
  }

}
