#include <vtkRungeKutta45.h>
extern "C" {
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"
#ifdef R_VTK_BASE
  SEXP R_vtkRungeKutta45_IsTypeOf( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkRungeKutta45 * _obj = (vtkRungeKutta45 * ) SexpToVtk(obj);
    int _res =_obj->IsTypeOf(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkRungeKutta45_IsA( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkRungeKutta45 * _obj = (vtkRungeKutta45 * ) SexpToVtk(obj);
    int _res =_obj->IsA(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkRungeKutta45_SafeDownCast( SEXP obj, SEXP o){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkObjectBase  *  _o = (vtkObjectBase * )  SexpToVtk(o);
    vtkRungeKutta45 * _obj = (vtkRungeKutta45 * ) SexpToVtk(obj);
    vtkRungeKutta45 *  _res =( vtkRungeKutta45 * )_obj->SafeDownCast(_o);
    res=VtkToSexp(_res,"vtkRungeKutta45");
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_o,"vtkObjectBase"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".o",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkRungeKutta45_NewInstance( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkRungeKutta45 * _obj = (vtkRungeKutta45 * ) SexpToVtk(obj);
    vtkRungeKutta45 *  _res =( vtkRungeKutta45 * )_obj->NewInstance();
    res=VtkToSexp(_res,"vtkRungeKutta45");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkRungeKutta45_ComputeNextStep( SEXP obj, SEXP xprev, SEXP xnext, SEXP t, SEXP delT, SEXP maxError, SEXP error){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     double  *  _xprev =  SexpTodouble(xprev);
     double  *  _xnext =  SexpTodouble(xnext);
    SET_LENGTH(t,1);
     double  *  _t =  SexpTodouble(t);
    SET_LENGTH(delT,1);
     double  *  _delT =  SexpTodouble(delT);
    SET_LENGTH(maxError,1);
     double  *  _maxError =  SexpTodouble(maxError);
    SET_LENGTH(error,1);
     double  *  _error =  SexpTodouble(error);
    vtkRungeKutta45 * _obj = (vtkRungeKutta45 * ) SexpToVtk(obj);
    int _res =_obj->ComputeNextStep(_xprev, _xnext,  * _t,  * _delT,  * _maxError,  * _error);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,5));
    PROTECT(res_names = allocVector(VECSXP,5));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_xprev,LENGTH(xprev)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".xprev",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_xnext,LENGTH(xnext)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".xnext",0));
    SET_VECTOR_ELT(ans,3,doubleToSexp(_delT,1));
    SET_VECTOR_ELT(res_names,3,charToSexp(".delT",0));
    SET_VECTOR_ELT(ans,4,doubleToSexp(_error,1));
    SET_VECTOR_ELT(res_names,4,charToSexp(".error",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkRungeKutta45_ComputeNextStep_v1( SEXP obj, SEXP xprev, SEXP dxprev, SEXP xnext, SEXP t, SEXP delT, SEXP maxError, SEXP error){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     double  *  _xprev =  SexpTodouble(xprev);
     double  *  _dxprev =  SexpTodouble(dxprev);
     double  *  _xnext =  SexpTodouble(xnext);
    SET_LENGTH(t,1);
     double  *  _t =  SexpTodouble(t);
    SET_LENGTH(delT,1);
     double  *  _delT =  SexpTodouble(delT);
    SET_LENGTH(maxError,1);
     double  *  _maxError =  SexpTodouble(maxError);
    SET_LENGTH(error,1);
     double  *  _error =  SexpTodouble(error);
    vtkRungeKutta45 * _obj = (vtkRungeKutta45 * ) SexpToVtk(obj);
    int _res =_obj->ComputeNextStep(_xprev, _dxprev, _xnext,  * _t,  * _delT,  * _maxError,  * _error);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,6));
    PROTECT(res_names = allocVector(VECSXP,6));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_xprev,LENGTH(xprev)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".xprev",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_dxprev,LENGTH(dxprev)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".dxprev",0));
    SET_VECTOR_ELT(ans,3,doubleToSexp(_xnext,LENGTH(xnext)));
    SET_VECTOR_ELT(res_names,3,charToSexp(".xnext",0));
    SET_VECTOR_ELT(ans,4,doubleToSexp(_delT,1));
    SET_VECTOR_ELT(res_names,4,charToSexp(".delT",0));
    SET_VECTOR_ELT(ans,5,doubleToSexp(_error,1));
    SET_VECTOR_ELT(res_names,5,charToSexp(".error",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkRungeKutta45_ComputeNextStep_v2( SEXP obj, SEXP xprev, SEXP xnext, SEXP t, SEXP delT, SEXP delTActual, SEXP minStep, SEXP maxStep, SEXP maxError, SEXP error){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     double  *  _xprev =  SexpTodouble(xprev);
     double  *  _xnext =  SexpTodouble(xnext);
    SET_LENGTH(t,1);
     double  *  _t =  SexpTodouble(t);
    SET_LENGTH(delT,1);
     double  *  _delT =  SexpTodouble(delT);
    SET_LENGTH(delTActual,1);
     double  *  _delTActual =  SexpTodouble(delTActual);
    SET_LENGTH(minStep,1);
     double  *  _minStep =  SexpTodouble(minStep);
    SET_LENGTH(maxStep,1);
     double  *  _maxStep =  SexpTodouble(maxStep);
    SET_LENGTH(maxError,1);
     double  *  _maxError =  SexpTodouble(maxError);
    SET_LENGTH(error,1);
     double  *  _error =  SexpTodouble(error);
    vtkRungeKutta45 * _obj = (vtkRungeKutta45 * ) SexpToVtk(obj);
    int _res =_obj->ComputeNextStep(_xprev, _xnext,  * _t,  * _delT,  * _delTActual,  * _minStep,  * _maxStep,  * _maxError,  * _error);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,6));
    PROTECT(res_names = allocVector(VECSXP,6));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_xprev,LENGTH(xprev)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".xprev",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_xnext,LENGTH(xnext)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".xnext",0));
    SET_VECTOR_ELT(ans,3,doubleToSexp(_delT,1));
    SET_VECTOR_ELT(res_names,3,charToSexp(".delT",0));
    SET_VECTOR_ELT(ans,4,doubleToSexp(_delTActual,1));
    SET_VECTOR_ELT(res_names,4,charToSexp(".delTActual",0));
    SET_VECTOR_ELT(ans,5,doubleToSexp(_error,1));
    SET_VECTOR_ELT(res_names,5,charToSexp(".error",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkRungeKutta45_ComputeNextStep_v3( SEXP obj, SEXP xprev, SEXP dxprev, SEXP xnext, SEXP t, SEXP delT, SEXP delTActual, SEXP minStep, SEXP maxStep, SEXP maxError, SEXP estErr){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     double  *  _xprev =  SexpTodouble(xprev);
     double  *  _dxprev =  SexpTodouble(dxprev);
     double  *  _xnext =  SexpTodouble(xnext);
    SET_LENGTH(t,1);
     double  *  _t =  SexpTodouble(t);
    SET_LENGTH(delT,1);
     double  *  _delT =  SexpTodouble(delT);
    SET_LENGTH(delTActual,1);
     double  *  _delTActual =  SexpTodouble(delTActual);
    SET_LENGTH(minStep,1);
     double  *  _minStep =  SexpTodouble(minStep);
    SET_LENGTH(maxStep,1);
     double  *  _maxStep =  SexpTodouble(maxStep);
    SET_LENGTH(maxError,1);
     double  *  _maxError =  SexpTodouble(maxError);
    SET_LENGTH(estErr,1);
     double  *  _estErr =  SexpTodouble(estErr);
    vtkRungeKutta45 * _obj = (vtkRungeKutta45 * ) SexpToVtk(obj);
    int _res =_obj->ComputeNextStep(_xprev, _dxprev, _xnext,  * _t,  * _delT,  * _delTActual,  * _minStep,  * _maxStep,  * _maxError,  * _estErr);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,7));
    PROTECT(res_names = allocVector(VECSXP,7));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,doubleToSexp(_xprev,LENGTH(xprev)));
    SET_VECTOR_ELT(res_names,1,charToSexp(".xprev",0));
    SET_VECTOR_ELT(ans,2,doubleToSexp(_dxprev,LENGTH(dxprev)));
    SET_VECTOR_ELT(res_names,2,charToSexp(".dxprev",0));
    SET_VECTOR_ELT(ans,3,doubleToSexp(_xnext,LENGTH(xnext)));
    SET_VECTOR_ELT(res_names,3,charToSexp(".xnext",0));
    SET_VECTOR_ELT(ans,4,doubleToSexp(_delT,1));
    SET_VECTOR_ELT(res_names,4,charToSexp(".delT",0));
    SET_VECTOR_ELT(ans,5,doubleToSexp(_delTActual,1));
    SET_VECTOR_ELT(res_names,5,charToSexp(".delTActual",0));
    SET_VECTOR_ELT(ans,6,doubleToSexp(_estErr,1));
    SET_VECTOR_ELT(res_names,6,charToSexp(".estErr",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkRungeKutta45_New() {
    SEXP R_res = NULL_USER_OBJECT;
    vtkRungeKutta45 * res= ( vtkRungeKutta45 * ) vtkRungeKutta45::New();
    R_res=toRPointer(res,"vtkRungeKutta45");
    return(R_res);
  }
#endif
}
