#include <vtkStructuredData.h>
extern "C" {
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"
#ifdef R_VTK_BASE
  SEXP R_vtkStructuredData_IsTypeOf( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    int _res =_obj->IsTypeOf(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_IsA( SEXP obj, SEXP type){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     char  *  _type =  SexpTochar(type);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    int _res =_obj->IsA(_type);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_SafeDownCast( SEXP obj, SEXP o){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
     vtkObjectBase  *  _o = (vtkObjectBase * )  SexpToVtk(o);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    vtkStructuredData *  _res =( vtkStructuredData * )_obj->SafeDownCast(_o);
    res=VtkToSexp(_res,"vtkStructuredData");
    PROTECT(ans = allocVector(VECSXP,2));
    PROTECT(res_names = allocVector(VECSXP,2));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_o,"vtkObjectBase"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".o",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_NewInstance( SEXP obj){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    vtkStructuredData *  _res =( vtkStructuredData * )_obj->NewInstance();
    res=VtkToSexp(_res,"vtkStructuredData");
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_SetDimensions( SEXP obj, SEXP inDim, SEXP dim){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(inDim,3);
     int  *  _inDim =  SexpToint(inDim);
    SET_LENGTH(dim,3);
     int  *  _dim =  SexpToint(dim);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    int _res =_obj->SetDimensions(_inDim, _dim);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,intToSexp(_inDim,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".inDim",0));
    SET_VECTOR_ELT(ans,2,intToSexp(_dim,3));
    SET_VECTOR_ELT(res_names,2,charToSexp(".dim",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_SetExtent( SEXP obj, SEXP inExt, SEXP ext){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(inExt,6);
     int  *  _inExt =  SexpToint(inExt);
    SET_LENGTH(ext,6);
     int  *  _ext =  SexpToint(ext);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    int _res =_obj->SetExtent(_inExt, _ext);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,intToSexp(_inExt,6));
    SET_VECTOR_ELT(res_names,1,charToSexp(".inExt",0));
    SET_VECTOR_ELT(ans,2,intToSexp(_ext,6));
    SET_VECTOR_ELT(res_names,2,charToSexp(".ext",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_GetDataDimension( SEXP obj, SEXP dataDescription){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(dataDescription,1);
     int  *  _dataDescription =  SexpToint(dataDescription);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    int _res =_obj->GetDataDimension( * _dataDescription);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,1));
    PROTECT(res_names = allocVector(VECSXP,1));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_GetCellPoints( SEXP obj, SEXP cellId, SEXP ptIds, SEXP dataDescription, SEXP dim){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(cellId,1);
     int  *  _cellId =  SexpToint(cellId);
     vtkIdList  *  _ptIds = (vtkIdList * )  SexpToVtk(ptIds);
    SET_LENGTH(dataDescription,1);
     int  *  _dataDescription =  SexpToint(dataDescription);
    SET_LENGTH(dim,3);
     int  *  _dim =  SexpToint(dim);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    _obj->GetCellPoints( * _cellId, _ptIds,  * _dataDescription, _dim);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_ptIds,"vtkIdList"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".ptIds",0));
    SET_VECTOR_ELT(ans,2,intToSexp(_dim,3));
    SET_VECTOR_ELT(res_names,2,charToSexp(".dim",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_GetPointCells( SEXP obj, SEXP ptId, SEXP cellIds, SEXP dim){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(ptId,1);
     int  *  _ptId =  SexpToint(ptId);
     vtkIdList  *  _cellIds = (vtkIdList * )  SexpToVtk(cellIds);
    SET_LENGTH(dim,3);
     int  *  _dim =  SexpToint(dim);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    _obj->GetPointCells( * _ptId, _cellIds, _dim);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_cellIds,"vtkIdList"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".cellIds",0));
    SET_VECTOR_ELT(ans,2,intToSexp(_dim,3));
    SET_VECTOR_ELT(res_names,2,charToSexp(".dim",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_GetCellNeighbors( SEXP obj, SEXP cellId, SEXP ptIds, SEXP cellIds, SEXP dim){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(cellId,1);
     int  *  _cellId =  SexpToint(cellId);
     vtkIdList  *  _ptIds = (vtkIdList * )  SexpToVtk(ptIds);
     vtkIdList  *  _cellIds = (vtkIdList * )  SexpToVtk(cellIds);
    SET_LENGTH(dim,3);
     int  *  _dim =  SexpToint(dim);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    _obj->GetCellNeighbors( * _cellId, _ptIds, _cellIds, _dim);
    PROTECT(ans = allocVector(VECSXP,4));
    PROTECT(res_names = allocVector(VECSXP,4));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,VtkToSexp(_ptIds,"vtkIdList"));
    SET_VECTOR_ELT(res_names,1,charToSexp(".ptIds",0));
    SET_VECTOR_ELT(ans,2,VtkToSexp(_cellIds,"vtkIdList"));
    SET_VECTOR_ELT(res_names,2,charToSexp(".cellIds",0));
    SET_VECTOR_ELT(ans,3,intToSexp(_dim,3));
    SET_VECTOR_ELT(res_names,3,charToSexp(".dim",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_ComputePointId( SEXP obj, SEXP dim, SEXP ijk){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(dim,3);
     int  *  _dim =  SexpToint(dim);
    SET_LENGTH(ijk,3);
     int  *  _ijk =  SexpToint(ijk);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    int _res =_obj->ComputePointId(_dim, _ijk);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,intToSexp(_dim,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".dim",0));
    SET_VECTOR_ELT(ans,2,intToSexp(_ijk,3));
    SET_VECTOR_ELT(res_names,2,charToSexp(".ijk",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
  SEXP R_vtkStructuredData_ComputeCellId( SEXP obj, SEXP dim, SEXP ijk){
    SEXP ans,res_names,res = NULL_USER_OBJECT;
    SET_LENGTH(dim,3);
     int  *  _dim =  SexpToint(dim);
    SET_LENGTH(ijk,3);
     int  *  _ijk =  SexpToint(ijk);
    vtkStructuredData * _obj = (vtkStructuredData * ) SexpToVtk(obj);
    int _res =_obj->ComputeCellId(_dim, _ijk);
    res=intToSexp(&_res,1);
    PROTECT(ans = allocVector(VECSXP,3));
    PROTECT(res_names = allocVector(VECSXP,3));
    SET_VECTOR_ELT(res_names,0,charToSexp("ret.val",0));
    SET_VECTOR_ELT(ans,0,res);
    SET_VECTOR_ELT(ans,1,intToSexp(_dim,3));
    SET_VECTOR_ELT(res_names,1,charToSexp(".dim",0));
    SET_VECTOR_ELT(ans,2,intToSexp(_ijk,3));
    SET_VECTOR_ELT(res_names,2,charToSexp(".ijk",0));
    setAttrib(ans, R_NamesSymbol, res_names);
    UNPROTECT(2);
    return ans;
  }
 
#endif
}
