#include <vtk/vtkXRenderWindowInteractor.h>
#include <vtk/vtkXOpenGLRenderWindow.h>

extern "C" {
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Utils.h"
#include <X11/X.h>
#include <X11/Intrinsic.h>
#include "R_ext/eventloop.h"
#include "R_ext/Parse.h"
#include "R_ext/GraphicsDevice.h"

XtAppContext VTKApp;
Display * VTKDisplay;
  SEXP Close;


void vtk_eventHandler(void *userData)
{
  XEvent event;
  char * zzz;
  while (XtAppPending(VTKApp)){
    XtAppNextEvent(VTKApp, &event);
    if ( event.type != ClientMessage ){
      XtDispatchEvent( &event);
    } else {
      Display * disp= event.xclient.display;
      Window win=event.xclient.window;
      XFetchName(disp,win,&zzz);
      defineVar(install(".rvtk.win.name"),charToSexp(zzz,1),R_GlobalEnv);
      EVAL(Close);
      XFree(zzz);
    }
  }

}  

SEXP RVTK_Init(SEXP Z){
    int argc=0;
    ParseStatus status;
    XtToolkitInitialize();
    VTKApp= XtCreateApplicationContext();
    Close=Z;
    //    VTKDisplay= XOpenDisplay(NULL);
    return NULL_USER_OBJECT;  
  }


class vtkXRenderWindowRInteractor : public vtkXRenderWindowInteractor
{
public:
  Display * GetDisplayId(){return this->DisplayId;};
  virtual void Enable();
  virtual void Disable();
  virtual void Initialize();
  void Setup();
protected:
  vtkXRenderWindowRInteractor();
  ~vtkXRenderWindowRInteractor();
private:
  InputHandler * RInputHandler;
  
};


vtkXRenderWindowRInteractor::vtkXRenderWindowRInteractor()
{

}

vtkXRenderWindowRInteractor::~vtkXRenderWindowRInteractor()
{

}

void vtkXRenderWindowRInteractor::Setup(){  
  addInputHandler(R_InputHandlers, ConnectionNumber(this->DisplayId),vtk_eventHandler, -1); 
  Widget widg = this->GetWidget();
  Atom wm_delete_window = XInternAtom(XtDisplay(widg), "WM_DELETE_WINDOW", False);
  XSetWMProtocols(XtDisplay(widg), XtWindow(widg), &wm_delete_window, 1);


}

void vtkXRenderWindowRInteractor::Initialize(){
  this->vtkXRenderWindowInteractor::Initialize(VTKApp);
} 

void vtkXRenderWindowRInteractor::Enable(){ 
  this->vtkXRenderWindowInteractor::Enable();
  printf("Enabled!");
  this->Setup();
}

void vtkXRenderWindowRInteractor::Disable(){  
      this-> vtkXRenderWindowInteractor::Disable();

}
 
  SEXP R_vtkXRenderWindowRInteractor_New() {
    SEXP R_res = NULL_USER_OBJECT;
    vtkXRenderWindowRInteractor * res= ( vtkXRenderWindowRInteractor * ) vtkXRenderWindowRInteractor::New();
     R_res=toRPointer(res,"vtkXRenderWindowRInteractor");
    return(R_res);
  }

SEXP R_vtkXRenderWindowRInteractor_Enable(SEXP obj){
  SEXP R_res = NULL_USER_OBJECT;
  vtkXRenderWindowRInteractor * _obj = (vtkXRenderWindowRInteractor * ) SexpToVtk(obj);
    _obj->vtkXRenderWindowRInteractor::Enable();
    return(R_res);

}

SEXP R_vtkXRenderWindowRInteractor_Initialize(SEXP obj){
  SEXP R_res = NULL_USER_OBJECT;
  vtkXRenderWindowRInteractor * _obj = (vtkXRenderWindowRInteractor * ) SexpToVtk(obj);
    _obj->vtkXRenderWindowRInteractor::Initialize();
    return(R_res);

}

SEXP R_vtkXRenderWindowRInteractor_Setup(SEXP obj){
  SEXP R_res = NULL_USER_OBJECT;
  vtkXRenderWindowRInteractor * _obj = (vtkXRenderWindowRInteractor * ) SexpToVtk(obj);
    _obj->vtkXRenderWindowRInteractor::Setup();
    return(R_res);

}



SEXP R_vtkXRenderWindowRInteractor_Disable(SEXP obj){
  SEXP R_res = NULL_USER_OBJECT;
  vtkXRenderWindowRInteractor * _obj = (vtkXRenderWindowRInteractor * ) SexpToVtk(obj);
    _obj->vtkXRenderWindowRInteractor::Disable();
    return(R_res);

}
}
